      SUBROUTINE ELSAIS(XEL,IRB)

!     LISSAGE SUR CINQ CYCLES D'UN TERME DE CYCLE LP 
!             FILTRE B (ANNEES 1 CENTRALES) 
!             TRONQUE A B1 (ANNEES 1 et -1) ET B2 (ANNEES 2 et -2)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4    B(5),B2(4),B1(3),ND2(2),NF2(2),ND1(2),NF1(2),
     .            YEL(NF),DXEL(NF,2),XEL(NF)

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

      DATA B/0.111,0.222,0.334,0.222,0.111/
C             J-2   J-1   *J*   J+1   J+2
      DATA B2/0.259,0.371,0.259,0.111/
C               1    *2*    3     4
C               N    N-1   N-2   N-3
      DATA B1/0.408,0.407,0.185/
C              *1*    2     3
C               N    N-1   N-2

      DO 90 I=1,NF   			! Ajout, juin 97   
      YEL(I)=0
      SAIS(I)=0
      DO 90 J=1,2      
      DXEL(I,J)=0                         
   90 CONTINUE   			! Ajout, juin 97

C      
C         REPERAGE DES AILES PERDUES DANS ELMOYP
C
      LP=LPS/INTERU+0.5      ! Nb de points par cycle
      NAN=5
      LPDEM=LP/2
      LD=LPDEM+1
      LF=NT-LPDEM
c        type*,'ELSAIS: LPS,LP,LPDEM,LD,LF',LPS,LP,LPDEM,LD,LF
C        
C        MOYENNE PAR FILTRE B,ANNEES 3 A N-2
c        type*,'MOYENNE PAR FILTRE B,ANNEES 3 A N-2'
C
      ND=LD+2*LP
      NFI=LF-2*LP
c        type*,ND,NFI
      IBOUCLE=0
   40 CONTINUE
      IBOUCLE=IBOUCLE+1
      DO 100 I=ND,NFI
         ACU=0
         DO 50 J=1,NAN
            KJ=J-NAN/2-1
            ACU=ACU+B(J)*XEL(I+KJ*LP)
   50    CONTINUE
C
C                 AFFECTATION DE SAIS (SAISONNIER)
C
         SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  100 CONTINUE
C
C                ANNEES 2 ET N-1
c                type*,'ANNEES 2 ET N-1'

      ND2(1)=ND-LP
      NF2(1)=ND-1
      ND2(2)=NFI+1
      NF2(2)=NFI+LP
      NAN2=NAN-1

c      TYPE*,'ELSAIS:',ND2(1),NF2(1),ND2(2),NF2(2),NAN2,LP,
c     .' ELMOYP  ANNEES 2 ET N-1 '

      DO 200 K=1,2
         IF(K.EQ.1) IS=+1
         IF(K.EQ.2) IS=-1
         DO 180 I = ND2(K),NF2(K)
            ACU=0
            DO 150 J=1,NAN2
               KJ=(J-NAN/2)*IS
               ACU=ACU+B2(J)*XEL(I+KJ*LP)
  150       CONTINUE
            SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  180    CONTINUE
  200 CONTINUE

C             ANNEES 1 ET N
c             type*,'ANNEES 1 ET N'

      ND1(1)=ND2(1)-LP
      NF1(1)=ND2(1)-1
      ND1(2)=NF2(2)+1
      NF1(2)=NF2(2)+LP
      NAN1=NAN-2

c     TYPE*,'ELSAIS:',ND1(1),NF1(1),ND1(2),NF1(2),NAN1,
c     .' ELMOYP  ANNEES 1 ET N '

      DO 300 K=1,2
         IF(K.EQ.1) IS=1
         IF(K.EQ.2) IS=-1
         DO 280 I=ND1(K),NF1(K)
            ACU=0
            DO 250 J=1,NAN1
               KJ=(J-NAN/2+1)*IS
               ACU=ACU+B1(J)*XEL(I+KJ*LP)
  250       CONTINUE
            SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  280    CONTINUE
  300 CONTINUE
C
C       RECONSTITUTION DES PREMIER ET DERNIER DEMI-CYCLE
c       type*,'RECONSTITUTION DES PREMIER ET DERNIER DEMI-CYCLE'
C
      DO 400 I=1,LPDEM
      SAIS(I)=SAIS(I+LP)
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
      J=NT-I+1
      SAIS(J)=SAIS(J-LP)
c         write(6,16) j,SERI(j),tend(j),SAIS(j) 
  400 CONTINUE

C       MOYENNE NULLE POUR SAIS par moyenne glissante sur un cycle
c       type*,'MOYENNE NULLE par moyenne glissante sur un cycle'

      XBM=0
      DO 420 I=1,NT
      XBM=XBM+SAIS(I)
c         write(6,16) j,SERI(j),tend(j),SAIS(j) 
  420 CONTINUE
      XBM=XBM/NT
	do 430 I=1,nt
	sais(I)=SAIS(I)-XBM
 430	continue

      IF(IRB.EQ.0.OR.IBOUCLE.EQ.2) GO TO 550
      IF(IRB.EQ.1.AND.IBOUCLE.EQ.1)  THEN
      DO 432 I=1,NT
      YEL(I)=XEL(I)-SAIS(I)
  432 CONTINUE


c	write(6,11) 
	write(16,11) 
 11	format(78('-')/'ELSAIS/ELCOPO')

        CALL ELCOPO(YEL,DXEL)

      DO 435 I=1,NT
      XEL(I)=XEL(I)-DXEL(I,1)
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
 16      format('Elsais',i5,3f10.3)
  435 CONTINUE        
      GO TO 40
              ENDIF
  550 RETURN
      END
