      FUNCTION VALMED(X,N)

c	Copie de [numrec]mdian1.f, 
c	en remplacant CALL SORT par CALL TRIDIN
c					       Auteur: M. Feissel 
c							sept 2001
      
      Implicit none

      Real*4 X(N),VALMED,XMAX,BINSUP
      Integer*4 I,N,N2,KT(N),LB(N)

      N2=N/2

      XMAX=BINSUP(X,N,2)		! max de la serie

      DO I=1,N
! 	 transformation en entier apres une normalisation 
! 	 supposant que la dynamique de la serie est < 10**6

	 KT(I)= X(I)/ABS(XMAX)*1.e+06	         
      ENDDO

      CALL TRIDIN(KT,LB,N)

      IF (2*N2.EQ.N) VALMED=0.5*( X(LB(N2))+X(LB(N2+1)) )	! N pair
      IF (2*N2.NE.N) VALMED=X(LB(N2+1))				! N impair

      RETURN
      END
