      SUBROUTINE ALLAN(NDIM,T,TAU,VARP,IECR)
C
C     PROGRAMME ALLAN, CALCULE LA VARIANCE D'ALLAN
C
	Integer*4   NF,Nst
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nst=1000)  ! Nb de variances d'Allan 
      Real*8 T(NDIM),B(NF)
      Real*4 DL(Nst),FL(Nst),VARP(Nst)
C
C     NDIM EST LA DIMENSION DU TABLEAU T****** DIMENSION MAXIMUM=NF
C     T EST LE TABLEAU QUI CONTIENT LES NOMBRES A ANALYSER
C
      IF(IECR.NE.0) WRITE(6,1) 
    1 FORMAT(//30X,'VARIANCES D''ALLAN',//,18X,'TAU',7x,'VAR(TAU)',4X,
     .'VAR(TAU)**0.5',3X,'LOG(TAU)',3X,'LOG(VAR)'//)
      K=1
      NP=NDIM-1
C
C     TAU EST L'INTERVALLE DE TEMPS SEPARANT 2 NOMBRES SUCCESSIFS
C
      NK=0
      NDEM=NDIM/2
      KL=0
  104 IF(K.GT.NDEM) GO TO 110
      MM=(NP/K)-1
      IF(MM.LE.0) GO TO 110
      NK=NK+1
      DO 105 I=1,NDIM
  105 B(I)=0
      IM=1
      J=1
  101 IN=IM+K-1
      IF(IN.GT.NP) GO TO 102
      DO 100 I=IM,IN
  100 B(J)=B(J)+T(I)
      B(J)=B(J)/FLOAT(K)
      IM=IN+1
      J=J+1
      GO TO 101
  102 JMAX=J-1
      JMA=J-2
      VAR=0
      DO 103 I=1,JMA
  103 VAR=VAR+(B(I+1)-B(I))**2
      VAR=VAR/FLOAT(2*MM)
      RVAR=SQRT(VAR)
C
C     RVAR A POUR UNITE : L'UNITE DE T/L'UNITE DE TAU
C
      R=TAU*K
      VARP(NK)=RVAR
      RL=ALOG10(R)
      VL=ALOG10(VAR)
      IF(IECR.NE.0) WRITE(6,2) R,VAR,RVAR,RL,VL           
    2 FORMAT(10X,F12.2,2E15.4,2(3X,F8.4))
      KL=KL+1
      DL(KL)=RL
      FL(KL)=VL
      K=2*K                                                     
C     1+K=K
      GO TO 104
  110 CONTINUE
      VARP(NK+1)=0.
      VARP(Nst)=PP
      RETURN
      END
