      SUBROUTINE ELCOPO(YEL,DXEL)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

      COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
      DIMENSION YEL(NF),DXEL(NF,2),DEL(NF,2)
C     LP=LPS/INTERU+0.5

      DO 400 I=1,NT
         DEL(I,1)=DATDEP+INTERU*(I-1)
         DEL(I,2)=(DEL(I,1)-44239.)/365.2422+1980.
c         write(6,16) I,yel(I) 
 16      format('Elcopo: ',i5,f10.3)
  400 CONTINUE
      SQ=0     

      DO 450 I=1,NT
         SQ=SQ+YEL(I)*YEL(I)
  450 CONTINUE
      
      SQ=SQRT(SQ/NT)
      SQB=0     
      NQB=0
      DO 480 I=1,NT
	 if(abs(YEL(I)).ge.belim*SQ) go to 480
	 NQB=NQB+1
         SQB=SQB+YEL(I)*YEL(I)
  480 CONTINUE
      nqf=nt

      IF (NQB.ne.0) THEN
         nqf=nqb
         SQ=SQRT(SQB/NQB)			
      ENDIF

c      WRITE(6,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
c      WRITE(16,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
    1 FORMAT(' RQM',F10.5,' sur ',I5,' valeurs',
     .      ' (apres ecretage a',f4.1,' sigma)',2F8.0)

      IBP=0
      IBI=0
      DO 500 I=1,NT
         POIDS=1.
         IF (ABS(YEL(I)).GT.BP*SQ) THEN
	    IBP=IBP+1
c            WRITE(6,2) IBP,I,DEL(I,1),DEL(I,2),YEL(I)
    2       FORMAT('GT.BP*SQ',I10,I5,F8.0,F10.3,F7.2)
            POIDS=0.
            DXEL(I,1)=YEL(I)-ELPOND(YEL,I,POIDS)
            TRUC=ELPOND(YEL,I,POIDS)
            DXEL(I,2)=YEL(I)                                 
         ELSE
            IF (ABS(YEL(I)).GT.BI*SQ) THEN
               IBI=IBI+1
c               WRITE(6,3) IBI,I,DEL(I,1),DEL(I,2),YEL(I)
 3             FORMAT('GT.BI*SQ',2I5,F8.0,F10.3,F7.2)
               POIDS=BP-ABS(YEL(I))/SQ
               DXEL(I,1)=YEL(I)-ELPOND(YEL,I,POIDS)
               TRUC=ELPOND(YEL,I,POIDS)
               DXEL(I,2)=YEL(I)*(1.-POIDS)                                 
            ENDIF
         ENDIF

c        IF(I.GT.230.AND.I.LT.280)
c     .  WRITE(6,4)I,YEL(I),POIDS,DXEL(I,1),DXEL(I,2),TRUC
    4    FORMAT(70X,I5,5F7.2)
  500 CONTINUE
      

      krub=100.*FLOAT(nt-nqf)/FLOAT(Nt)
      kruc=100.*FLOAT(IBP)/FLOAT(NQF)
      krud=100.*FLOAT(IBI)/FLOAT(NQF)

c      write(6,66) NQF,krub,belim,kruc,BP,krud,BI
      write(16,66)NQF,krub,belim,kruc,BP,krud,BI
 66   format(i6,' mes. apres ecret. de',i3,'% >',f4.1,'*sig',
     .       '. Rabot:',i3,'% >',f4.1,'*sig;',
     .                           i3,'% >',f4.1,'*sig')

c      WRITE(16,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
c    1 FORMAT(' RQM',F7.3,' sur',I5,' valeurs',
c     .      ' (apres ecretage a',f4.1,' sigma)',2F8.0)
c	type*,' '
      RETURN
      END

